--add shoulders? will it be necessary with imp xmog of the future? time will tell...

local StealthHat = addon
local addonString = "StealthHat" 

--main frame
local addon = CreateFrame("FRAME", addonString, UIParent)
addon:RegisterEvent("ADDON_LOADED")
addon:EnableMouse(false)

addon:SetScript("OnEvent", function(self, event, ...) self:OnEvent(event, ...) end)
addon:Show()

function addon:OnEvent(event, ...)
	if event == "ADDON_LOADED" then
		local name = ...
		if name == addonString then
			self:UnregisterEvent("ADDON_LOADED")
					
			if not EQUIPMENT_DATA then
				EQUIPMENT_DATA = {}
			end		
			self.setData = EQUIPMENT_DATA
			
			if not EQUIPMENT_SETTINGS then
				EQUIPMENT_SETTINGS = {}
			end
			self.settings = EQUIPMENT_SETTINGS
			
			self.setPanels = {}
						
			--throttle starts at goal to immediately check first change
			self.checkThrottleGoal = 2
			self.checkThrottle = self.checkThrottleGoal
			
			
			--hook set management functions
			if PaperDollEquipmentManagerPane then
				--hooks
				PaperDollEquipmentManagerPane:HookScript("OnShow", function() self:LoadFrames() end)
				PaperDollEquipmentManagerPane:HookScript("OnVerticalScroll", function() self:UpdateFrames() end)
				PaperDollEquipmentManagerPane:HookScript("OnMouseWheel", function() self:UpdateFrames(true) end)
				
				--modification
				hooksecurefunc("SaveEquipmentSet", function() self:SaveEquipmentSet() end)
				hooksecurefunc("ModifyEquipmentSet", function(oldName, newName) self:SaveEquipmentSet(oldName, newName) end)
				hooksecurefunc("DeleteEquipmentSet", function(setName) self:DeleteEquipmentSet(setName) end)
				
				--set changing
				self:RegisterEvent("UNIT_INVENTORY_CHANGED")
				--self:RegisterEvent("EQUIPMENT_SWAP_FINISHED")
				
				--hooksecurefunc("UseEquipmentSet", function() self:UpdateEquipmentDelay() end)
				--hooksecurefunc("EquipmentManager_EquipSet", function() self.checkThrottle = 0 self:UpdateEquipmentDelay() end)
				
				--global helm toggle button
				local button = CreateFrame("CHECKBUTTON", nil, PaperDollEquipmentManagerPane, "UICheckButtonTemplate")
				self.GlobalHelmToggleButton =  button
				button:SetPoint("TOPRIGHT", "PaperDollSidebarTabs", "TOPRIGHT", 0, 0)
				button:SetWidth(16)
				button:SetHeight(16)
				button:SetScript("OnShow", function(button) button:SetChecked(self.settings.globalShowHelm or false) end)
				button:SetScript("OnClick", function(button) self:ToggleGlobalShowHelm(button) end)
				button:SetScript("OnEnter", function(button)
					GameTooltip:SetOwner(button, "ANCHOR_TOPLEFT", 20)
					GameTooltip:SetText("Check to show helm on all characters.")
					GameTooltip:Show()
				end)
				button:SetScript("OnLeave", function() GameTooltip:Hide() end)
				
				--global cloak toggle button
				button = CreateFrame("CHECKBUTTON", nil, PaperDollEquipmentManagerPane, "UICheckButtonTemplate")
				self.GlobalCloakToggleButton =  button
				button:SetPoint("TOP", self.GlobalHelmToggleButton, "BOTTOM", 0, 0)
				button:SetWidth(16)
				button:SetHeight(16)
				button:SetScript("OnShow", function(button) button:SetChecked(self.settings.globalShowCloak or false) end)
				button:SetScript("OnClick", function(button) self:ToggleGlobalShowCloak(button) end)
				button:SetScript("OnEnter", function(button)
					GameTooltip:SetOwner(button, "ANCHOR_TOPLEFT", 20)
					GameTooltip:SetText("Check to show cloak on all characters.")
					GameTooltip:Show()
				end)
				button:SetScript("OnLeave", function() GameTooltip:Hide() end)
			end
			
			--hook bag coloring update function
			hooksecurefunc("ContainerFrame_Update", function(frame) self:ColorBagBorders(frame) end)		--entire container
			hooksecurefunc("BankFrameItemButton_Update", function(frame) self:ColorBagBorders(frame, true) end)		--single bank slot
		end
	
	elseif event == "EQUIPMENT_SWAP_FINISHED" then
		self.checkThrottle = 0
		self:UpdateEquipmentDelay()
	
	elseif event == "UNIT_INVENTORY_CHANGED" then
		local unit = ...
		if unit == "player" then
			self.checkThrottle = 0
			self:UpdateEquipmentDelay()
		end
	end
end

--[[CLOAK AND HAT CONTROL]]
--create and attach checkboxes
function addon:LoadFrames()
	for id = 1, GetNumEquipmentSets() do
		local panel = _G["PaperDollEquipmentManagerPaneButton"..id]
		
		if panel then
			if not self.setPanels[id] then
				local frame, button, texture
				--container for buttons
				frame = CreateFrame("FRAME", addonString..id, panel)
				self.setPanels[id] = frame
				frame:SetAllPoints(panel)
				frame:EnableMouse(false)
				frame:Hide()
				
				--cloak toggle button
				button = CreateFrame("CHECKBUTTON", nil, frame, "UICheckButtonTemplate")
				self.setPanels[id].CloakButton =  button
				button:SetPoint("RIGHT", panel:GetName().."EditButton", "LEFT", 0, 0)
				button:SetWidth(16)
				button:SetHeight(16)
				button:SetScript("OnClick", function(button) self:ToggleShowCloak(button) end)
				button:SetScript("OnEnter", function(button)
					frame:Show()
					GameTooltip:SetOwner(button, "ANCHOR_TOPLEFT", 20)
					GameTooltip:SetText("Show Cloak")
					GameTooltip:Show()
				end)
				button:SetScript("OnLeave", function() frame:Hide() GameTooltip:Hide() end)
				
				--helm toggle button
				button = CreateFrame("CHECKBUTTON", nil, frame, "UICheckButtonTemplate")
				self.setPanels[id].HelmButton =  button
				button:SetPoint("RIGHT", self.setPanels[id].CloakButton, "LEFT", 0, 0)
				button:SetWidth(16)
				button:SetHeight(16)
				button:SetScript("OnClick", function(button) self:ToggleShowHelm(button) end)
				button:SetScript("OnEnter", function(button)
					frame:Show()
					GameTooltip:SetOwner(button, "ANCHOR_TOPLEFT", 20)
					GameTooltip:SetText("Show Helm")
					GameTooltip:Show()
				end)
				button:SetScript("OnLeave", function() frame:Hide() GameTooltip:Hide() end)
				
				--color picker button
				button = CreateFrame("BUTTON", nil, frame)
				self.setPanels[id].ColorButton =  button
				button:SetPoint("RIGHT", self.setPanels[id].HelmButton, "LEFT", 0, 0)
				button:SetWidth(16)
				button:SetHeight(16)
				button:SetScript("OnClick", function() PlaySound("igMainMenuOptionCheckBoxOn") self:ShowColorPicker(button) end)
				texture = button:CreateTexture()
				button.colorBox = texture
				texture:SetTexture("Interface\\ChatFrame\\ChatFrameColorSwatch")
				texture:SetPoint("CENTER")
				texture:SetSize(16, 16)
				button:SetScript("OnShow", function(button) 
					local color = self.setData[button:GetParent():GetParent().name].color or {r=1, g=0, b=0}
					button.colorBox:SetVertexColor(color.r, color.g, color.b)
				end)
				button:SetScript("OnEnter", function(button)
					frame:Show()
					GameTooltip:SetOwner(button, "ANCHOR_TOPLEFT", 20)
					GameTooltip:SetText("Set Color")
					GameTooltip:Show()
				end)
				button:SetScript("OnLeave", function() frame:Hide() GameTooltip:Hide() end)
				
				--show/hide buttons
				--set pane buttonc
				panel:HookScript("OnEnter", function() if panel.name then frame:Show() end end)
				panel:HookScript("OnLeave", function() frame:Hide() end)
				
				--edit button
				_G[panel:GetName().."EditButton"]:HookScript("OnEnter", function() frame:Show() end)
				_G[panel:GetName().."EditButton"]:HookScript("OnLeave", function() frame:Hide() end)
				
				--delete button
				_G[panel:GetName().."DeleteButton"]:HookScript("OnEnter", function() frame:Show() end)
				_G[panel:GetName().."DeleteButton"]:HookScript("OnLeave", function() frame:Hide() end)
			end
		end
	end
		
	self:UpdateFrames()
end

--set state of checkboxes to match data
function addon:UpdateFrames(showFrameFlag)
	for id, info in pairs(self.setPanels) do
		local frame = self.setPanels[id]
		local setName = frame:GetParent().name
		
		--check checkboxes and prepare data.  ignore "new set" button
		if setName then
			--update the frame with data or create new entry
			if self.setData[setName] == nil then
				self.setData[setName] = {
					showHelm = false,
					showCloak = false,
					color = {r = 1, g = 0, b = 0}		--default color red
				}
			end			
			frame.HelmButton:SetChecked(self.setData[setName].showHelm)
			frame.CloakButton:SetChecked(self.setData[setName].showCloak)
		end
		
		--usually hide the frames except for the mousewheel	--TODO change this?
		if not showFrameFlag then
			frame:Hide()
		end
	end
end

--toggle sets helm display
function addon:ToggleShowHelm(button)
	local setName = button:GetParent():GetParent().name
	
	if self.setData[setName] then
		self.setData[setName].showHelm = button:GetChecked()
		self:UpdateEquipmentDelay()
	end
	
	self:PlayButtonSound(button)
end

--toggle helm display globally
function addon:ToggleGlobalShowHelm(button)
	self.settings.globalShowHelm = button:GetChecked()
	self:UpdateEquipmentDelay()
	
	self:PlayButtonSound(button)
end

--toggle sets cloak display
function addon:ToggleShowCloak(button)
	local setName = button:GetParent():GetParent().name
	
	if self.setData[setName] then
		self.setData[setName].showCloak = button:GetChecked()
		self:UpdateEquipmentDelay()
	end
	
	self:PlayButtonSound(button)
end

--toggle cloak display globally
function addon:ToggleGlobalShowCloak(button)
	self.settings.globalShowCloak = button:GetChecked()
	self:UpdateEquipmentDelay()
	
	self:PlayButtonSound(button)
end

--play sound for the button when its clicked
function addon:PlayButtonSound(button)
	if button:GetChecked() then
		PlaySound("igMainMenuOptionCheckBoxOn")
	else
		PlaySound("igMainMenuOptionCheckBoxOff")
	end
end

--new or modified set
function addon:SaveEquipmentSet(oldName, newName)
	if oldName and oldName ~= newName then
		self.setData[newName] = self.setData[oldName]
		self.setData[oldName] = nil
	end
	
	self:LoadFrames()
end

--delete set
function addon:DeleteEquipmentSet(setName)
	self.setData[setName] = nil
	self:UpdateEquipmentDelay()
	self:UpdateFrames()
end

--update the character model with choices
function addon:UpdateEquipmentDisplay()
	local showHelm, showCloak = false, false
	for setName, info in pairs(self.setData) do
		local icon, setID, isEquipped, numItems, numEquipped, unknown, numMissing, numIgnored = GetEquipmentSetInfoByName(setName)
		
		if isEquipped then
			if info.showHelm then
				showHelm = true
			end
			
			if info.showCloak then
				showCloak = true
			end
		end
	end
	
	if self.settings.globalShowHelm then
		showHelm = true
	end
	
	if self.settings.globalShowCloak then
		showCloak = true
	end
	
	ShowHelm(showHelm)
	ShowCloak(showCloak)
end

--throttled change of character display. rapid changes of checkboxes results in inaccurate display
function addon:OnUpdate(elapsed)
	self.checkThrottle = self.checkThrottle + elapsed
	if self.checkThrottle >= self.checkThrottleGoal then
		if self.displayChanges then
			self.checkThrottle = 0
			self.displayChanges = false
			self:UpdateEquipmentDisplay()
		else
			self:SetScript("OnUpdate", nil)
		end
	end
end

--start timer to update character model
function addon:UpdateEquipmentDelay()
	self.displayChanges = true
	self:SetScript("OnUpdate", function(frame, elapsed) self:OnUpdate(elapsed) end)
end


--[[BAG SLOT COLORING]]
--find the containerID, slotID and frame
function addon:ColorBagBorders(frame, isBank)
	local containerID, slotID
	if isBank then
		if not frame:GetName() then return end		--dont include bank bag row
		containerID = frame:GetParent():GetID()
		slotID = frame:GetID()
	else
		containerID = frame:GetID()
	end
			
	if slotID then
		--main bank slot
		self:ColorBagSlot(containerID, slotID, frame)
	else
		--normal bag, bank bag
		for slotID = 1, GetContainerNumSlots(containerID) do
			self:ColorBagSlot(containerID, slotID, frame)
		end
	end
end

--color the appropriate bag slot
function addon:ColorBagSlot(containerID, slotID, frame)
	if containerID == REAGENTBANK_CONTAINER then return end
	if containerID == KEYRING_CONTAINER then return end
	
	local border
	local borderGraphic = "Interface\\ContainerFrame\\UI-Icon-QuestBorder"
	
	if containerID == BANK_CONTAINER then
		border = frame["IconQuestTexture"]
	else
		border = _G[frame:GetName().."Item"..( GetContainerNumSlots(containerID) + 1 - slotID ).."IconQuestTexture"]		--reverse ID cuz
	end
	
	if not border then return end

	local texture, count, locked, quality, readable, lootable, link, isFiltered = GetContainerItemInfo(containerID, slotID)
	local isInSet, setString = GetContainerItemEquipmentSetInfo(containerID, slotID)
	
	if not border:IsVisible() then
	
		border:SetDesaturated(false)
		border:SetTexture(nil)
		border:SetVertexColor(1, 1, 1)
		border:Hide()
	
		local acceptedQuality = {0, 2, 3, 4, 5, 6, 7}
		if tContains(acceptedQuality, quality) then
			border:SetTexture(borderGraphic)
			border:SetDesaturated(true)
			
			local r, g, b = GetItemQualityColor(quality)
			border:SetVertexColor(r, g, b)
			
			border:Show()
		end
		
		--color set items
		if isInSet then
			border:SetTexture(borderGraphic)
			border:SetDesaturated(true)
			border:SetVertexColor(1, 0, 0)		--default red
			
			local setList = { strsplit(", ", setString) }
			for _, setName in pairs(setList) do
				if self.setData[setName] then
					if self.setData[setName].color then
						border:SetVertexColor(self.setData[setName].color.r, self.setData[setName].color.g, self.setData[setName].color.b)
					end
				end
			end
			
			border:Show()
		end
	end
end

--show color picker
function addon:ShowColorPicker(button)
	self.selectedSet = self.setData[button:GetParent():GetParent().name]
	if self.selectedSet then
		local function changedCallback(restore)
			if not ColorPickerFrame:IsVisible() then
				local r, g, b
				if restore then
					r, g, b = unpack(restore)
				else
					r, g, b = ColorPickerFrame:GetColorRGB()
				end
				
				if self.selectedSet then
					self.selectedSet.color = {
						r = round(r, 2),
						g = round(g, 2),
						b = round(b, 2)
					}
				end
			end
		end
		local color = self.selectedSet.color or {r=1, g=0, b=0}
		ColorPickerFrame:SetColorRGB(color.r, color.g, color.b)
		
		ColorPickerFrame.previousValues = {color.r, color.g, color.b}
		ColorPickerFrame.func, ColorPickerFrame.cancelFunc = changedCallback, changedCallback
		
		ColorPickerFrame:Show()
	end
end




















